Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 637546 - mail-mta/exim-4.91-r2 stable request
Summary: mail-mta/exim-4.91-r2 stable request
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Stabilization (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Fabian Groffen
URL:
Whiteboard: Was: mail-mta/exim with =net-libs/lib...
Keywords:
Depends on: 657148
Blocks: glibc-rpc glibc-2.26-stable
  Show dependency tree
 
Reported: 2017-11-15 05:55 UTC by Vadim A. Misbakh-Soloviov (mva)
Modified: 2019-01-16 22:53 UTC (History)
2 users (show)

See Also:
Package list:
mail-mta/exim-4.91-r2
Runtime testing required: ---
stable-bot: sanity-check+


Attachments
exim-4.89-r3:20171115-052749.log (exim-4.89-r3:20171115-052749.log,7.91 KB, text/plain)
2017-11-15 06:08 UTC, Vadim A. Misbakh-Soloviov (mva)
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Vadim A. Misbakh-Soloviov (mva) 2017-11-15 05:55:13 UTC
After glibc 2.26's splitting net-libs/libnsl, net-libs/rpcsvc-protoand net-libs/libtirpc out of it, Exim (all in-portage versions) started to fail builds, until `I/usr/include/tirpc"` is added to {C,CXX}FLAGS.

I guess, tirpc's headers should either be symlinked to old (in-glibc) location (for backward compatibility) or patch net-libs/libnsl to `#include <tirpc/rpc/rpc.h>` instead of just `<rpc/rpc.h>` (and same for other `rpc/*` includes if applicable)

Reproducible: Always
Comment 1 Vadim A. Misbakh-Soloviov (mva) 2017-11-15 06:08:07 UTC
Created attachment 504266 [details]
exim-4.89-r3:20171115-052749.log

Here is exim build log,if any
Comment 2 Vadim A. Misbakh-Soloviov (mva) 2017-11-15 16:05:54 UTC
By the way, this report is not fully correct, since there is no `mail-mta/exim[nis]` versions compatible with glibc-2.26 in the tree, in the first place ('cause it requires glibc[rpc] which can't be satisfied with glibc-2.26).

I just didn't noticed this before, since I was rebuilding glibc-dependent packages (including exim) with -O to solve the blocks on world-upgrade, when faced this issue.
Comment 3 Fabian Groffen gentoo-dev 2017-12-17 17:34:28 UTC
does adding net-libs/libtirpc to the dependencies help?
Comment 4 Vadim A. Misbakh-Soloviov (mva) 2018-02-04 06:54:42 UTC
(In reply to Fabian Groffen from comment #3)
> does adding net-libs/libtirpc to the dependencies help?

Nope, it doesn't. See #c0:

> I guess, tirpc's headers should either be symlinked to old (in-glibc)
> location (for backward compatibility) or patch net-libs/libnsl to `#include
> <tirpc/rpc/rpc.h>` instead of just `<rpc/rpc.h>` (and same for other `rpc/*`
> includes if applicable)

"old location" was /usr/include/rpc/* (unlike current /usr/include/tirpc/rpc/*).
So, as /usr/include/rpcsvc/nis.h from net-libs/libnsl have "#include <rpc/rpc.h>" in the related headers, gcc looking for them in "old" location (/usr/include) and fails.

So, since fixing each and every NIS-related software to add "-I${EPREFIX}/usr/include/tirpc" to C{,XX}FLAGS is not a way to go, I see two working ways, as I said in #c0. Either:
1) symlink tirpc/*.h headers to the parent directory, or
2) fix /usr/include/rpcsvc/nis.h from net-libs/libnsl (maybe, something else) to '#include <tirpc/rpc/rpc.h>', and not just '<rpc/rpc.h>'
Comment 5 Andreas K. Hüttel gentoo-dev 2018-02-22 23:30:06 UTC
Not really a libnsl problem. The RPC include path needs fixing.
Comment 6 Larry the Git Cow gentoo-dev 2018-05-05 14:59:05 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=f9f46770cb19a4d24ac02b9d49768976c13124a2

commit f9f46770cb19a4d24ac02b9d49768976c13124a2
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2018-05-05 14:57:52 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2018-05-05 14:58:49 +0000

    mail-mta/exim: Add revbump building with libtirpc, bug 637546
    
    This still needs stabilization, preferably in sync with glibc-2.26.
    
    Bug: https://bugs.gentoo.org/637546
    Package-Manager: Portage-2.3.33, Repoman-2.3.9

 mail-mta/exim/exim-4.91-r2.ebuild | 554 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 554 insertions(+)
Comment 7 Stabilization helper bot gentoo-dev 2018-06-20 10:01:10 UTC
An automated check of this bug failed - repoman reported dependency errors (117 lines truncated): 

> dependency.bad mail-mta/exim/exim-4.91-r2.ebuild: DEPEND: alpha(default/linux/alpha/13.0) ['>=net-libs/libnsl-1:=']
> dependency.bad mail-mta/exim/exim-4.91-r2.ebuild: RDEPEND: alpha(default/linux/alpha/13.0) ['>=net-libs/libnsl-1:=']
> dependency.bad mail-mta/exim/exim-4.91-r2.ebuild: DEPEND: alpha(default/linux/alpha/13.0/desktop) ['>=net-libs/libnsl-1:=']
Comment 8 Larry the Git Cow gentoo-dev 2018-06-21 06:33:49 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=8a6179a12c4b31ba233731146f4078a5f13b4135

commit 8a6179a12c4b31ba233731146f4078a5f13b4135
Author:     Sergei Trofimovich <slyfox@gentoo.org>
AuthorDate: 2018-06-21 06:32:55 +0000
Commit:     Sergei Trofimovich <slyfox@gentoo.org>
CommitDate: 2018-06-21 06:33:33 +0000

    mail-mta/exim: stable 4.91-r2 for ia64, bug #637546
    
    Bug: https://bugs.gentoo.org/637546
    Package-Manager: Portage-2.3.40, Repoman-2.3.9
    RepoMan-Options: --include-arches="ia64"

 mail-mta/exim/exim-4.91-r2.ebuild | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)
Comment 9 Mikle Kolyada archtester Gentoo Infrastructure gentoo-dev Security 2018-06-23 18:13:53 UTC
amd64 stable
Comment 10 Thomas Deutschmann gentoo-dev Security 2018-06-25 23:22:54 UTC
x86 stable
Comment 11 Tobias Klausmann gentoo-dev 2018-06-27 17:23:54 UTC
Stable on alpha.
Comment 12 Larry the Git Cow gentoo-dev 2018-07-14 17:54:06 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=f4da6cb8b9bb005922849b2cc42901c52cf4b646

commit f4da6cb8b9bb005922849b2cc42901c52cf4b646
Author:     Rolf Eike Beer <eike@sf-mail.de>
AuthorDate: 2018-07-14 17:26:43 +0000
Commit:     Sergei Trofimovich <slyfox@gentoo.org>
CommitDate: 2018-07-14 17:53:44 +0000

    mail-mta/exim: stable 4.91-r2 for sparc
    
    Bug: https://bugs.gentoo.org/637546
    Package-Manager: Portage-2.3.40, Repoman-2.3.9
    RepoMan-Options: --include-arches="sparc"

 mail-mta/exim/exim-4.91-r2.ebuild | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)
Comment 13 Mikle Kolyada archtester Gentoo Infrastructure gentoo-dev Security 2018-07-22 02:20:33 UTC
arm stable
Comment 14 Matt Turner gentoo-dev 2018-09-11 20:13:43 UTC
ppc/ppc64 stable. I've pinged hppa people on IRC.
Comment 15 Larry the Git Cow gentoo-dev 2018-09-11 20:51:44 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=061ff65b498e0076335679bfb54aa59980e080f1

commit 061ff65b498e0076335679bfb54aa59980e080f1
Author:     Andreas K. Hüttel <dilfridge@gentoo.org>
AuthorDate: 2018-09-11 20:49:24 +0000
Commit:     Andreas K. Hüttel <dilfridge@gentoo.org>
CommitDate: 2018-09-11 20:49:24 +0000

    mail-mta/exim: Drop old, drop hppa to ~hppa
    
    Closes: https://bugs.gentoo.org/637546
    Package-Manager: Portage-2.3.49, Repoman-2.3.10

 mail-mta/exim/Manifest              |   2 -
 mail-mta/exim/exim-4.90.1-r1.ebuild | 528 ----------------------------------
 mail-mta/exim/exim-4.91-r1.ebuild   | 547 ------------------------------------
 3 files changed, 1077 deletions(-)